package hu.bme.mit.socialnetwork.form.hierarchy;

import hu.bme.mit.socialnetwork.form.socialnetwork.Community;
import hu.bme.mit.socialnetwork.form.socialnetwork.Person;

import org.eclipse.jface.databinding.viewers.TreeStructureAdvisor;

/**
 * @author Zoltan Ujhelyi
 *
 */
public class SocialnetworkStructureAdvisor extends TreeStructureAdvisor {

	@Override
	public Object getParent(Object element) {
		if (element instanceof Community) {
			return ((Community) element).getParent();
		} else if (element instanceof Person) {
			return ((Person) element).getMembership().get(0);
		}
		return null;
	}

	@Override
	public Boolean hasChildren(Object element) {
		if (element instanceof Community
				&& (!((Community) element).getChildren().isEmpty()
				|| !((Community) element).getMembers().isEmpty())) {
			return Boolean.TRUE;
		}
		return super.hasChildren(element);
	}
}

